//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Gold
#property indicator_width1  2
#property indicator_style2  STYLE_DOT
#property indicator_level1  0
#property indicator_level2  20
#property indicator_level3  80

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT; // Time frame
extern int    StoPeriod   = 21;
extern int    StoSlowing  = 10;
extern ENUM_STO_PRICE StoPrice    =  0;
extern int    WprPeriod   = 21;
extern int    MomPeriod   = 21;
extern ENUM_APPLIED_PRICE MomPrice    = PRICE_CLOSE;
extern double MomModifier =  0;
extern int    RsiPeriod   = 21;
extern ENUM_APPLIED_PRICE RsiPrice    = PRICE_CLOSE;
extern int    CciPeriod   = 21;
extern ENUM_APPLIED_PRICE CciPrice    = PRICE_TYPICAL;
extern int    UltFast     =  7;
extern int    UltMiddle   = 14;
extern int    UltSlow     = 28;
extern int    UltFastK    =  4;
extern int    UltMiddleK  =  2;
extern int    UltSlowK    =  1;
extern int    MfiPeriod   = 14;
extern int    LrPeriod    = 21;
extern int    EmaPeriod   =  4;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

extern bool   ShowVlines         = true;
extern string vlinesIdentifier   = "kubi 2 Vlines";
extern color  vlinesUpColor      = LimeGreen;
extern color  vlinesDnColor      = Red;
extern bool   Interpolate        = true;           // Interpolate

double lrvalue[];
double emavalue[];
double value[];
double temp[];
double trend[];
int    window;
string shortName;
string indicatorFileName;
bool   returnBars;
#define _mtfCall(_buff,_y) iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,StoPeriod,StoSlowing,StoPrice,WprPeriod,MomPeriod,MomPrice,MomModifier,RsiPeriod,RsiPrice,CciPeriod,CciPrice,UltFast,UltMiddle,UltSlow,UltFastK,UltMiddleK,UltSlowK,MfiPeriod,LrPeriod,EmaPeriod,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,ShowVlines,vlinesIdentifier,vlinesUpColor,vlinesDnColor,_buff,_y)

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,lrvalue);
   SetIndexBuffer(1,emavalue);
   SetIndexBuffer(2,value);
   SetIndexBuffer(3,temp);
   SetIndexBuffer(4,trend);
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
   shortName = " kubi 2 ";
   IndicatorShortName(shortName);
   return(0);
}
int deinit() { if(ShowVlines) deleteVlines(); return(0); }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   window = WindowFind(shortName);
   int i,counted_bars=IndicatorCounted();
   double divider = UltFastK+UltMiddleK+UltSlowK;
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { lrvalue[0] = MathMin(limit+1,Bars-1); return(0); }
            if (TimeFrame != _Period)
            {
               limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/_Period));
               for(i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                     lrvalue[i]  = _mtfCall(0,y);
                     emavalue[i] = _mtfCall(1,y);
                  
                     //
                     //
                     //
                     //
                     //
                  
                     if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                        #define _interpolate(buff) buff[i+k] = buff[i]+(buff[i+n]-buff[i])*k/n
                        int n,k; datetime ctime = iTime(NULL,TimeFrame,y);
                           for(n = 1; (i+n)<Bars && Time[i+n] >= ctime; n++) continue;
                           for(k = 1; k<n && (i+n)<Bars && (i+k)<Bars; k++) 
                           {
                              _interpolate(lrvalue);
                              _interpolate(emavalue);
                           }                              
               }
               return(0);
            }
  

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--) temp[i] = Close[i]-MathMin(Low[i],Close[i+1]);
   for(i=limit; i>=0; i--)
   {
      double atrf = iATR(NULL,0,UltFast  ,i);
      double atrm = iATR(NULL,0,UltMiddle,i);
      double atrs = iATR(NULL,0,UltSlow  ,i);
      double ult  = 0;
      if (atrf!=0 && atrm !=0 && atrs !=0)
             ult = (UltFastK  *iMAOnArray(temp,0,UltFast  ,0,MODE_SMA,i)/atrf +
                    UltMiddleK*iMAOnArray(temp,0,UltMiddle,0,MODE_SMA,i)/atrm +
                    UltSlowK  *iMAOnArray(temp,0,UltSlow  ,0,MODE_SMA,i)/atrs)/divider*100;
                    
            //
            //
            //
            //
            //
                                
                                
            value[i] = (iStochastic(NULL,0,StoPeriod,1,StoSlowing,MODE_SMA,StoPrice,MODE_MAIN,i)+
                        iWPR(NULL,0,WprPeriod,i)+
                        iMomentum(NULL,0,MomPeriod,MomPrice,i)+MomModifier+
                        iRSI(NULL,0,RsiPeriod,RsiPrice,i)+
                        iCCI(NULL,0,CciPeriod,CciPrice,i)+
                        iMFI(NULL,0,MfiPeriod,i)+ult)/7.0;
            lrvalue[i]  = iLinr(value[i],LrPeriod,i,0);                        
            emavalue[i] = iEma(lrvalue[i],EmaPeriod,i,0);
            trend[i] = trend[i+1];
             if (lrvalue[i] > emavalue[i]) trend[i] =  1;
             if (lrvalue[i] < emavalue[i]) trend[i] = -1;
             manageVline(i);
	}
	manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

double workEma[][1];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r=Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

//
//
//
//
//

double workLinr[][1];
double iLinr(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workLinr,0)!= Bars) ArrayResize(workLinr,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
   
      period = MathMax(period,1);
      workLinr[r][instanceNo] = price;
         double lwmw = period; double lwma = lwmw*price;
         double sma  = price;
         for(int k=1; k<period && (r-k)>=0; k++)
         {
            double weight = period-k;
                   lwmw  += weight;
                   lwma  += weight*workLinr[r-k][instanceNo];  
                   sma   +=        workLinr[r-k][instanceNo];
         }             
   
   return(3.0*lwma/lwmw-2.0*sma/period);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  timeFrameToString(_Period)+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" kubi 2 "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," kubi 2 "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageVline(int i)
{
   if (ShowVlines && window>-1)
   {
      deleteVline(Time[i]);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] == 1) drawVline(i,vlinesUpColor);
         if (trend[i] ==-1) drawVline(i,vlinesDnColor);
      }
   }
}               

//
//
//
//
//


void drawVline(int i,color theColor)
{
  string name = vlinesIdentifier+":"+Time[i];
  ObjectCreate(name, OBJ_VLINE, window, Time[i], 0);
     ObjectSet(name, OBJPROP_STYLE, 2);    
     ObjectSet(name, OBJPROP_WIDTH, 1);
     ObjectSet(name, OBJPROP_COLOR, theColor);
     ObjectSet(name, OBJPROP_BACK, true);
}

//
//
//
//
//

void deleteVlines()
{
   string lookFor       = vlinesIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteVline(datetime time)
{
   string lookFor = vlinesIdentifier+":"+time; ObjectDelete(lookFor);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
